/*
 * (C) Copyright 2002,2003 Motorola,Inc.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* mpc8540ads board configuration file */
/* please refer to doc/README.mpc85xxads for more info */
/* make sure you change the MAC address and other network params first,
 * search for CONFIG_ETHADDR,CONFIG_SERVERIP,etc in this file
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/* #define CONFIG_CW		1 */

/* High Level Configuration Options */
#define CONFIG_BOOKE		1	    /* BOOKE 			*/
#define CONFIG_E500		1	    /* BOOKE e500 family	*/
#define CONFIG_MPC85xx		1	    /* MPC8540/MPC8560		*/
#define CONFIG_MPC8540		1	    /* MPC8540 specific	        */
#define CONFIG_DIF165		1	    /* DIF165 board specific    */

#define CONFIG_DUALBOOT                     /* support recovery kernel  */
#define CONFIG_PCI 1	         	    /* pci ethernet support	*/
#undef  CONFIG_PCI_SLAVE                    /* PCI Host and Standalone Mode*/

#define CONFIG_TSEC_ENET 		    /* tsec ethernet support    */
#undef CONFIG_E1000


#ifdef CONFIG_TSEC_ENET
#  define DEBUG_PORT tsec
#  define CONFIG_MII		  1	/* MII PHY management	*/
#  define CONFIG_MPC85XX_TSEC1    1
#  undef CONFIG_MPC85XX_TSEC2
#  undef CONFIG_MPC85XX_FEC
#  define TSEC1_PHY_ADDR          7
#  define TSEC2_PHY_ADDR	  4	
#  define FEC_PHY_ADDR            2
#  define TSEC1_PHYIDX            0
#  define TSEC2_PHYIDX            0
#  define FEC_PHYIDX              0
#  define CONFIG_ETHPRIME         "Freescale ENET0"
#  define CONFIG_PHY_M88E1011     1     /* GigaBit Ether PHY    */
#  define INTEL_LXT971_PHY	  0	/* on EVAL board. It is Davicom 9161 on ADS. */
#else
#  define DEBUG_PORT e1000
#  undef CONFIG_TSEC_ENET
#  undef CONFIG_MPC85XX_TSEC1
#  undef CONFIG_MPC85XX_TSEC2
#  undef CONFIG_MPC85XX_FEC
#endif

#define CONFIG_NET_MULTI 1

#define CONFIG_ENV_OVERWRITE
#undef  CONFIG_SPD_EEPROM                   /* unuse SPD EEPROM for DDR setup */
#undef  CONFIG_DDR_ECC			    /* only for ECC DDR module  */
#define CONFIG_DDR_DLL                      /* possible DLL fix needed  */

/* Using Localbus SDRAM to emulate flash before we can program the flash,
 * normally you only need a flash-boot image(u-boot.bin),if unsure undef this.
 * Not availabe for EVAL board
 */
#undef CONFIG_RAM_AS_FLASH

#define CONFIG_SYS_CLK_FREQ	33000000    /* most pci cards are 33Mhz */

#if !defined(CONFIG_SPD_EEPROM)             /* manually set up DDR parameters */
#define CONFIG_DDR_SETTING
#endif

/* below can be toggled for performance analysis. otherwise use default */
#define CONFIG_L2_CACHE		    	    /* toggle L2 cache */
#undef  CONFIG_BTB			    /* toggle branch predition */
#undef  CONFIG_ADDR_STREAMING		    /* toggle addr streaming */

#define CONFIG_BOARD_PRE_INIT	1	    /* Call board_pre_init */

#undef	CFG_DRAM_TEST			    /* memory test, takes time */
#define CFG_MEMTEST_START	0x00700000  /* memtest works on */
#define CFG_MEMTEST_END		0x00800000

#if defined(CONFIG_E1000) && defined(CONFIG_TSEC_ENET)
#error "You can only use either PCI Ethernet Card or TSEC Ethernet, not both."
#endif

/*
 * Base addresses -- Note these are effective addresses where the
 * actual resources get mapped (not physical addresses)
 */
#define CFG_CCSRBAR_DEFAULT 	0xff700000	/* CCSRBAR Default	*/
#define CFG_CCSRBAR		0xf0000000	/* relocated CCSRBAR 	*/
#define CFG_IMMR		CFG_CCSRBAR	/* PQII uses CFG_IMMR	*/
#define CFG_GPIOCR              (CFG_CCSRBAR + 0xE0030)
#define CFG_GPOUTDR             (CFG_CCSRBAR + 0xE0040)
#define CFG_DEVDISR             (CFG_CCSRBAR + 0xE0070)

#define CFG_DDR_SDRAM_BASE	0x00000000	/* DDR is system memory  */
#define CFG_SDRAM_BASE		CFG_DDR_SDRAM_BASE
#define CFG_SDRAM_SIZE		256             /* 256MB                 */

#define CFG_LBC_SDRAM_BASE	0xf0000000	/* Localbus SDRAM        */
#define CFG_LBC_SDRAM_SIZE	0		/* LBC SDRAM is 0MB	 */

#define CFG_FLASH_AREA_BASE      0xf8000000       /* include JIG ROM aria */
#undef CFG_FLASH_32MB 

#ifdef CFG_FLASH_32MB
#define CFG_FLASH_JIG_BASE      0xfa000000      /* start of FLASH 32M (JIG) */
#define CFG_FLASH_BASE		0xfe000000	/* start of FLASH 32M    */
#define CFG_BR0_PRELIM		0xfe001001	/* port size 16bit	 */
#define	CFG_OR0_PRELIM		0xfe000945	/* 32MB address. 32MB Flash */
#define CFG_MAX_FLASH_SECT	256		/* sectors per device (32MB) */
#else
#define CFG_FLASH_JIG_BASE      0xfb000000      /* start of FLASH 16M(JIG) */
#define CFG_FLASH_BASE		0xff000000	/* start of FLASH 16M    */
#define CFG_BR0_PRELIM		0xfe001001	/* port size 16bit	*/
/* #define	CFG_OR0_PRELIM		0xff006f67 */   /* 16MB Flash(EVAL8540) */
/* #define	CFG_OR0_PRELIM		0xff000945 */	/* 16MB Flash(DIF-165)	*/
// #define	CFG_OR0_PRELIM		0xfe000945	/* 32MB address 16MB Flash */
#define	CFG_OR0_PRELIM		0xfe000fc7	/* 32MB address 16MB Flash */
#define CFG_BR2_PRELIM		0xfa001001	/* port size 16bit	*/
// #define	CFG_OR2_PRELIM		0xfe000945	/* 32MB address 16MB Flash */
#define	CFG_OR2_PRELIM		0xfe000fc7	/* 32MB address 16MB Flash */
#define CFG_MAX_FLASH_SECT	128		/* sectors per device (16MB)  */
#endif

#define CFG_MAX_FLASH_BANKS	2		/* number of banks	*/
#undef	CFG_FLASH_CHECKSUM
#define CFG_FLASH_ERASE_TOUT	60000	/* Timeout for Flash Erase (in ms)*/
#define CFG_FLASH_WRITE_TOUT    1000	/* Timeout for Flash Write (in ms)*/
#define CFG_FLASH_CFI		1

#define CFG_MONITOR_BASE    	TEXT_BASE	/* start of monitor */

#if (CFG_MONITOR_BASE < CFG_FLASH_BASE)
#define CFG_RAMBOOT
#else
#undef  CFG_RAMBOOT
#endif

#define SPD_EEPROM_ADDRESS	0x51		/* DDR DIMM */
#if defined(CONFIG_DDR_SETTING)
#define CFG_DDR_CS0_BNDS        0x0000000F      /* 0-256MB              */

#define CFG_DDR_CS0_CONFIG      0x80000102
#define CFG_DDR_TIMING_1        0x37344321
#define CFG_DDR_TIMING_2        0x00000800      /* P9-45,may need tuning */
#define CFG_DDR_CONTROL         0xc2220000      /* unbuffered,DYN_PWR */
#define CFG_DDR_MODE            0x00000062      /* DLL,normal,seq,4/2.5 */
#define CFG_DDR_INTERVAL        0x04F00000      /* autocharge,no open page */
#endif

#undef CONFIG_CLOCKS_IN_MHZ

/* Local Bus */
#define CFG_LBC_LCRR		0x00030004	/* local bus freq divider */
#define CFG_LBC_BASE            0xf0000000      /* LBC BASE */
#define CFG_LBC_GPIO_BASE       0xf1000000      /* GPIO AREA 4MB */
#define CFG_BR4_PRELIM		0xf1201801	/* GPIO(outport) 1MB */
#define CFG_OR4_PRELIM		0xfff00935
#define CFG_BR5_PRELIM		0xf1101901	/* GPIO(inport, read-only) 1MB */
#define CFG_OR5_PRELIM		0xfff00935
#define CFG_BR6_PRELIM		0xf1001801	/* JIG-GPIO(outport) 1MB */
#define CFG_OR6_PRELIM		0xfff00935
#define CFG_LBC_GPIO_OUT_0      (CFG_BR4_PRELIM & 0xfff00000)
#define CFG_LBC_GPIO_IN_0       (CFG_BR5_PRELIM & 0xfff00000)
#define CFG_LBC_GPIO_JIG_0      (CFG_BR6_PRELIM & 0xfff00000)

/* Local Bus GPIO */
#define CFG_LBC_GPIO_OUT_0_DEFAULT  0xfffc0000 /* outport initial value */
#define CFG_LBC_GPIO_JIG_0_DEFAULT  0xffff0000 /* jig outport initial value */
#define CONFIG_OUTP_POWER_OK        0x00020000 /* outport */
#define CONFIG_DIPSW_MASK           0xffe20000 /* inport */
#define CONFIG_DIPSW_S1000_1        0x80000000 /* inport */
#define CONFIG_DIPSW_S1000_2        0x40000000 /* inport */
#define CONFIG_DIPSW_S1000_3        0x20000000 /* inport */
#define CONFIG_DIPSW_S1000_4        0x10000000 /* inport */
#define CONFIG_DIPSW_S1000_5        0x08000000 /* inport */
#define CONFIG_DIPSW_S1000_6        0x04000000 /* inport */
#define CONFIG_DIPSW_S1000_7        0x02000000 /* inport */
#define CONFIG_DIPSW_S1000_8        0x01000000 /* inport */
#define CONFIG_DIPSW_S1001_1        0x00800000 /* inport */
#define CONFIG_DIPSW_S1001_2        0x00400000 /* inport */
#define CONFIG_DIPSW_S1001_3        0x00200000 /* inport */
#define CONFIG_PWR_BTN_X            0x00100000 /* inport */
#define CONFIG_RECEV_MODE_X         0x00080000 /* inport */
#define CONFIG_SHUTDOWN_REQ         0x00040000 /* inport */
#define CONFIG_DIPSW_S1001_7        0x00020000 /* inport */
#define CONFIG_JIG_EXIST_X          0x00010000 /* inport */
#define CONFIG_JIG_ROM_ON_X         CONFIG_DIPSW_S1001_7 /* inport */

/* Monitor Memory */
#define CONFIG_L1_INIT_RAM
#define CFG_INIT_RAM_LOCK 	1
#define CFG_INIT_RAM_ADDR   	0x40000000 	/* Initial RAM address	*/
#define CFG_INIT_RAM_END    	0x4000	    	/* End of used area in RAM */

#define CFG_GBL_DATA_SIZE  	128		/* num bytes initial data */
#define CFG_GBL_DATA_OFFSET	(CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)
#define CFG_INIT_SP_OFFSET	CFG_GBL_DATA_OFFSET

#define CFG_MONITOR_LEN	    	(256 * 1024)    /* Reserve 256 kB for Mon */
#define CFG_MALLOC_LEN	    	(128 * 1024)    /* Reserved for malloc */

/* Serial Port */
#define CONFIG_CONS_INDEX     1
#undef	CONFIG_SERIAL_SOFTWARE_FIFO
#define CFG_NS16550
#define CFG_NS16550_SERIAL
#define CFG_NS16550_REG_SIZE    1
#define CFG_NS16550_CLK		get_bus_freq(0)
#define CONFIG_BAUDRATE	 	115200

#define CFG_BAUDRATE_TABLE  \
	{300, 600, 1200, 2400, 4800, 9600, 19200, 38400,115200}

#define CFG_NS16550_COM1        (CFG_CCSRBAR+0x4500)
#define CFG_NS16550_COM2        (CFG_CCSRBAR+0x4600)

/* Use the HUSH parser */
#define CFG_HUSH_PARSER
#ifdef  CFG_HUSH_PARSER
#define CFG_PROMPT_HUSH_PS2 "> "
#endif

/* I2C */
#define  CONFIG_HARD_I2C		/* I2C with hardware support*/
#undef	CONFIG_SOFT_I2C			/* I2C bit-banged		*/
#define CFG_I2C_SPEED		400000	/* I2C speed and slave address	*/
#define CFG_I2C_SLAVE		0x7F
#define CFG_I2C_NOPROBES        {0x69}	/* Don't probe these addrs */

/* General PCI */
#define CFG_PCI1_MEM_BASE	0x80000000
#define CFG_PCI1_MEM_PHYS	CFG_PCI1_MEM_BASE
#define CFG_PCI1_MEM_SIZE	0x20000000	/* 512M */
#define CFG_PCI1_IO_BASE	0x00000000
#define CFG_PCI1_IO_PHYS	0xe2000000
#define CFG_PCI1_IO_SIZE	0x01000000	/* 16M */

#if defined(CONFIG_PCI)
#define CONFIG_PCI_PNP	        1      	/* do pci plug-and-play */
#define CONFIG_PCI_SCAN_SHOW    1       /* show pci devices on startup  */
#define CFG_PCI_SUBSYS_VENDORID 0x1057  /* Motorola */
#define CFG_PCI_SUBSYS_DEVICEID 0x0008
#endif


/* Environment */
#ifndef CFG_RAMBOOT
  #if defined(CONFIG_RAM_AS_FLASH)
  #define CFG_ENV_IS_NOWHERE
  #define CFG_ENV_ADDR		(CFG_FLASH_BASE + 0x100000)
  #define CFG_ENV_SIZE		0x2000
  #else
  #define CFG_ENV_IS_IN_FLASH	1
  #define CFG_ENV_ADDR		0xfff40000
  #define CFG_ENV_SECT_SIZE	0x20000	/* 128K(one sector) for env */
  #endif
  #define CFG_ENV_SIZE		0x2000
#else
#define CFG_NO_FLASH		1	/* Flash is not usable now	*/
#define CFG_ENV_IS_NOWHERE	1	/* Store ENV in memory only	*/
#define CFG_ENV_ADDR		(CFG_MONITOR_BASE - 0x1000)
#define CFG_ENV_SIZE		0x2000
#endif


#define CONFIG_BOOTDELAY	    1 	/* -1 disable autoboot */
#define CONFIG_ZERO_BOOTDELAY_CHECK 1
#define CONFIG_LOADS_ECHO	 1	/* echo on for serial download	*/
#define CFG_LOADS_BAUD_CHANGE	 1	/* allow baudrate change	*/

/* bootselect */
#define CONFIG_BOOTSELECT       "auto" /* auto | normal | recovery */
#define CONFIG_BOOTARGS	        "root=/dev/ram rw console=ttyS0,115200"
#define CONFIG_BOOTARGS_R       "root=/dev/ram rw console=ttyS0,115200 bootmode=recovery"
#define CONFIG_BOOTCOMMAND	"bootm 0xff000000 0xff280000"
#define CONFIG_BOOTCOMMAND_R	"bootm 0xff140000 0xff980000"
#define CONFIG_BOOTSEL_IOP          CFG_LBC_GPIO_IN_0
#define CONFIG_DIPSW_BOOTSEL_MASK   (CONFIG_DIPSW_S1001_1 | CONFIG_DIPSW_S1001_2) 
#define CONFIG_DIPSW_AUTO           CONFIG_DIPSW_BOOTSEL_MASK
#define CONFIG_DIPSW_NORMAL         CONFIG_DIPSW_S1001_1
#define CONFIG_DIPSW_RECOVERY       CONFIG_DIPSW_S1001_2
#define CONFIG_DIPSW_PWRCTRL        CONFIG_DIPSW_S1001_3

#if defined(CFG_RAMBOOT) || defined(CONFIG_RAM_AS_FLASH)
  #if defined(CONFIG_PCI)
  #define  CONFIG_COMMANDS	((CONFIG_CMD_DFL | CFG_CMD_PING | CFG_CMD_PCI | CFG_CMD_I2C ) & \
				 ~(CFG_CMD_ENV | CFG_CMD_LOADS ))
  #else
  #define  CONFIG_COMMANDS	((CONFIG_CMD_DFL | CFG_CMD_PING | CFG_CMD_I2C ) & \
				 ~(CFG_CMD_ENV | \
				  CFG_CMD_LOADS ))
  #endif
#else
  #if defined(CONFIG_PCI)
  #define  CONFIG_COMMANDS	(CONFIG_CMD_DFL | CFG_CMD_PCI | CFG_CMD_PING | CFG_CMD_NET  | CFG_CMD_I2C | CFG_CMD_BSP )
  #else
  #define  CONFIG_COMMANDS	(CONFIG_CMD_DFL | CFG_CMD_PING | CFG_CMD_I2C | CFG_CMD_DIAG | CFG_CMD_BSP )
  #endif
#endif
#include <cmd_confdefs.h>

#undef CONFIG_WATCHDOG			/* watchdog disabled		*/

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP			/* undef to save memory		*/
#define CFG_LOAD_ADDR   0x2000000       /* default load address */
#define CFG_PROMPT	"dif165=> "	/* Monitor Command Prompt	*/
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CFG_CBSIZE	1024		/* Console I/O Buffer Size	*/
#else
#define CFG_CBSIZE	256		/* Console I/O Buffer Size	*/
#endif
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */
#define CFG_MAXARGS	16		/* max number of command args	*/
#define CFG_BARGSIZE	CFG_CBSIZE	/* Boot Argument Buffer Size	*/
#define CFG_HZ		1000		/* decrementer freq: 1 ms ticks */

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */
#define CFG_BOOTMAPSZ	(8 << 20) 	/* Initial Memory map for Linux */

/* Cache Configuration */
#define CFG_DCACHE_SIZE	32768
#define CFG_CACHELINE_SIZE	32
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CFG_CACHELINE_SHIFT	5	/* log base 2 of the above value */
#endif

/*
 * Internal Definitions
 *
 * Boot Flags
 */
#define BOOTFLAG_COLD	0x01		/* Normal Power-On: Boot from FLASH */
#define BOOTFLAG_WARM	0x02		/* Software reboot		*/

#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CONFIG_KGDB_BAUDRATE	230400	/* speed to run kgdb serial port */
#define CONFIG_KGDB_SER_INDEX	2	/* which serial port to use */
#endif

/* NOTE: change below for your network setting!!! */

#if defined(CONFIG_TSEC_ENET)
#define CONFIG_ETHADDR  00:01:af:07:9b:8a
#endif

#define CONFIG_ROOTPATH  /nfsroot
#define CONFIG_BOOTFILE  vmlinux.img.gz.u-boot

#define CONFIG_SERVERIP         192.168.1.1
#define CONFIG_IPADDR           192.168.1.10
#define CONFIG_GATEWAYIP        192.168.1.254
#define CONFIG_NETMASK          255.255.255.0

#define CONFIG_LOADADDR  200000   /* default location for tftp and bootm */

#define CONFIG_HOSTNAME         DIF165

#define CONFIG_BOARD_UNIQUE_DATA
#define CFG_BUDATA_ADDR 0xfff60000
#define CFG_BUDATA_SECTOR_SIZE 0x20000
#define CFG_BUDATA_SIZE 256
#define CFG_MAX_ETHDEV 1

#endif	/* __CONFIG_H */

